#ifndef __PNL_CLIENT_H
#define __PNL_CLIENT_H

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <hash.h>
#include <pnsock.h>

typedef struct _CLIENT_STRUCT pnclient_t;

struct _CLIENT_STRUCT {
	int sockfd;
	int regist_complete_flag;
	struct sockaddr_in cliaddr;
	time_t timestamp;
	void (*registration_complete)(pnclient_t *);
	int (*regist_completed)(pnclient_t *);
	pnclient_t *next;
};

struct _PNCLIENT_HANDLE {
	hash_t *h_client;
	fd_set rfds;
	int maxfd;
};
typedef struct _PNCLIENT_HANDLE pnclient_handle_t;

extern int pnclient_count(pnclient_handle_t *handle);
extern int pnclient_init(pnclient_handle_t *handle);
extern pnclient_t *pnclient_create(int sockfd, struct sockaddr_in cliaddr) ;
extern int pnclient_add(pnclient_handle_t *handle, pnclient_t *add_cli);
extern int pnclient_delete(pnclient_handle_t *handle, pnclient_t *del_cli);
extern hash_t *pnclient_get_hash(pnclient_handle_t *handle);
extern void pnclient_free(pnclient_handle_t *handle);
extern pnclient_t *pnclient_lookup(pnclient_handle_t *handle, int sockfd);
extern fd_set pnclient_get_fdset(pnclient_handle_t *handle);
extern int pnclient_get_maxfd(pnclient_handle_t *handle);
extern time_t pnclient_get_timestamp(pnclient_t *cli);
extern void pnclient_update_timestamp(pnclient_t *cli, time_t unix_secs);


#endif /* __PNL_CLIENT_H */
