#ifndef PNL_PNQUEUE_H_
#define PNL_PNQUEUE_H_

/* data_t */
struct _PNQUEUE_DATA {
	void *dp;		/* data pointer */
	int size;		/* size of data */
};
typedef struct _PNQUEUE_DATA pnqueue_data_t;

/* node_t */
struct _PNQUEUE_NODE {
	pnqueue_data_t *data;
	struct _PNQUEUE_NODE *prev;
	struct _PNQUEUE_NODE *next;
};
typedef struct _PNQUEUE_NODE pnqueue_node_t;

/* handle_t */
struct _PNQUEUE_HANDLE {
	unsigned int q_size;
	pnqueue_node_t *head;
	pnqueue_node_t *tail;
	pnqueue_node_t *cur_p;
};
typedef struct _PNQUEUE_HANDLE pnqueue_handle_t;

extern void pnqueue_datafree(pnqueue_data_t *data);
extern int pnqueue_init(pnqueue_handle_t *que);
extern void pnqueue_destroy(pnqueue_handle_t *handle);
extern int pnqueue_put(pnqueue_handle_t *handle, pnqueue_data_t *data);
extern int pnqueue_get(pnqueue_handle_t *handle, pnqueue_data_t *data);
extern void pnqueue_scan(pnqueue_handle_t *handle);
extern pnqueue_node_t *pnqueue_next(pnqueue_handle_t *handle);
extern int pnqueue_get_size(pnqueue_handle_t *handle);



#endif /* PNL_PNQUEUE_H_ */
